'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _chai = require('chai');

var _chai2 = _interopRequireDefault(_chai);

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _sinonChai = require('sinon-chai');

var _sinonChai2 = _interopRequireDefault(_sinonChai);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_chai2.default.use(_sinonChai2.default);

describe('Class.onInherited', function () {
  describe("using class declarations", function () {
    it("is called when a class is inherited from", function () {
      var callback = _sinon2.default.spy();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            callback(child);
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child = function (_Parent) {
          (0, _inherits3.default)(_Child, _Parent);

          function _Child() {
            (0, _classCallCheck3.default)(this, _Child);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child).apply(this, arguments));
          }

          return _Child;
        }(Parent);

        Object.defineProperty(_Child, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child2 = Parent.onInherited(_Child);

            if (_Child2 !== void 0) {
              if (typeof _Child2 == 'function' && _Child2.name !== 'Child') {
                Object.defineProperty(_Child2, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child = _Child2;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("can redefine the value of the declared class", function () {
      var replacement = _sinon2.default.stub();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            return replacement;
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child3 = function (_Parent2) {
          (0, _inherits3.default)(_Child3, _Parent2);

          function _Child3() {
            (0, _classCallCheck3.default)(this, _Child3);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child3).apply(this, arguments));
          }

          return _Child3;
        }(Parent);

        Object.defineProperty(_Child3, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child4 = Parent.onInherited(_Child3);

            if (_Child4 !== void 0) {
              if (typeof _Child4 == 'function' && _Child4.name !== 'Child') {
                Object.defineProperty(_Child4, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child3 = _Child4;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child3;
      }();

      (0, _chai.expect)(Child).to.equal(replacement);
    });

    it("can redefine the value of the declared class to a falsy value other than undefined", function () {
      // Not sure why you'd want to do this, but...

      var Falserator = function () {
        function Falserator() {
          (0, _classCallCheck3.default)(this, Falserator);
        }

        (0, _createClass3.default)(Falserator, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            return false;
          }
        }]);
        return Falserator;
      }();

      var FalseratedChild = function () {
        var _FalseratedChild = function (_Falserator) {
          (0, _inherits3.default)(_FalseratedChild, _Falserator);

          function _FalseratedChild() {
            (0, _classCallCheck3.default)(this, _FalseratedChild);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_FalseratedChild).apply(this, arguments));
          }

          return _FalseratedChild;
        }(Falserator);

        Object.defineProperty(_FalseratedChild, "name", {
          value: 'FalseratedChild',
          configurable: true
        });

        if ("onInherited" in Falserator) {
          if (typeof Falserator.onInherited == 'function') {
            var _FalseratedChild2 = Falserator.onInherited(_FalseratedChild);

            if (_FalseratedChild2 !== void 0) {
              if (typeof _FalseratedChild2 == 'function' && _FalseratedChild2.name !== 'FalseratedChild') {
                Object.defineProperty(_FalseratedChild2, "name", {
                  value: 'FalseratedChild',
                  configurable: true
                });
              }

              _FalseratedChild = _FalseratedChild2;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _FalseratedChild;
      }();

      (0, _chai.expect)(FalseratedChild).to.equal(false);

      var Nullifier = function () {
        function Nullifier() {
          (0, _classCallCheck3.default)(this, Nullifier);
        }

        (0, _createClass3.default)(Nullifier, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            return null;
          }
        }]);
        return Nullifier;
      }();

      var NullifiedChild = function () {
        var _NullifiedChild = function (_Nullifier) {
          (0, _inherits3.default)(_NullifiedChild, _Nullifier);

          function _NullifiedChild() {
            (0, _classCallCheck3.default)(this, _NullifiedChild);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NullifiedChild).apply(this, arguments));
          }

          return _NullifiedChild;
        }(Nullifier);

        Object.defineProperty(_NullifiedChild, "name", {
          value: 'NullifiedChild',
          configurable: true
        });

        if ("onInherited" in Nullifier) {
          if (typeof Nullifier.onInherited == 'function') {
            var _NullifiedChild2 = Nullifier.onInherited(_NullifiedChild);

            if (_NullifiedChild2 !== void 0) {
              if (typeof _NullifiedChild2 == 'function' && _NullifiedChild2.name !== 'NullifiedChild') {
                Object.defineProperty(_NullifiedChild2, "name", {
                  value: 'NullifiedChild',
                  configurable: true
                });
              }

              _NullifiedChild = _NullifiedChild2;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _NullifiedChild;
      }();

      (0, _chai.expect)(NullifiedChild).to.equal(null);
    });

    it("has a reliable name property", function () {
      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {}
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child5 = function (_Parent3) {
          (0, _inherits3.default)(_Child5, _Parent3);

          function _Child5() {
            (0, _classCallCheck3.default)(this, _Child5);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child5).apply(this, arguments));
          }

          return _Child5;
        }(Parent);

        Object.defineProperty(_Child5, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child6 = Parent.onInherited(_Child5);

            if (_Child6 !== void 0) {
              if (typeof _Child6 == 'function' && _Child6.name !== 'Child') {
                Object.defineProperty(_Child6, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child5 = _Child6;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child5;
      }();

      (0, _chai.expect)(Child.name).to.equal("Child");
    });
  });

  describe("using class expressions", function () {
    it("is called when a class is inherited from", function () {
      var callback = _sinon2.default.spy();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            callback(child);
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child7 = function (_Parent4) {
          (0, _inherits3.default)(_Child7, _Parent4);

          function _Child7() {
            (0, _classCallCheck3.default)(this, _Child7);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child7).apply(this, arguments));
          }

          return _Child7;
        }(Parent);

        Object.defineProperty(_Child7, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child8 = Parent.onInherited(_Child7);

            if (_Child8 !== void 0) {
              if (typeof _Child8 == 'function' && _Child8.name !== 'Child') {
                Object.defineProperty(_Child8, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child7 = _Child8;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child7;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("can redefine the value of the declared class", function () {
      var replacement = _sinon2.default.stub();

      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            return replacement;
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child9 = function (_Parent5) {
          (0, _inherits3.default)(_Child9, _Parent5);

          function _Child9() {
            (0, _classCallCheck3.default)(this, _Child9);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child9).apply(this, arguments));
          }

          return _Child9;
        }(Parent);

        Object.defineProperty(_Child9, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child10 = Parent.onInherited(_Child9);

            if (_Child10 !== void 0) {
              if (typeof _Child10 == 'function' && _Child10.name !== 'Child') {
                Object.defineProperty(_Child10, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child9 = _Child10;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child9;
      }();

      (0, _chai.expect)(Child).to.equal(replacement);
    });

    it("can redefine the value of the declared class to a falsy value other than undefined", function () {
      // Not sure why you'd want to do this, but...
      var Falserator = function () {
        function Falserator() {
          (0, _classCallCheck3.default)(this, Falserator);
        }

        (0, _createClass3.default)(Falserator, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            return false;
          }
        }]);
        return Falserator;
      }();

      var FalseratedChild = function () {
        var _FalseratedChild3 = function (_Falserator2) {
          (0, _inherits3.default)(_FalseratedChild3, _Falserator2);

          function _FalseratedChild3() {
            (0, _classCallCheck3.default)(this, _FalseratedChild3);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_FalseratedChild3).apply(this, arguments));
          }

          return _FalseratedChild3;
        }(Falserator);

        Object.defineProperty(_FalseratedChild3, "name", {
          value: 'FalseratedChild',
          configurable: true
        });

        if ("onInherited" in Falserator) {
          if (typeof Falserator.onInherited == 'function') {
            var _FalseratedChild4 = Falserator.onInherited(_FalseratedChild3);

            if (_FalseratedChild4 !== void 0) {
              if (typeof _FalseratedChild4 == 'function' && _FalseratedChild4.name !== 'FalseratedChild') {
                Object.defineProperty(_FalseratedChild4, "name", {
                  value: 'FalseratedChild',
                  configurable: true
                });
              }

              _FalseratedChild3 = _FalseratedChild4;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _FalseratedChild3;
      }();

      (0, _chai.expect)(FalseratedChild).to.equal(false);

      var Nullifier = function () {
        function Nullifier() {
          (0, _classCallCheck3.default)(this, Nullifier);
        }

        (0, _createClass3.default)(Nullifier, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            return null;
          }
        }]);
        return Nullifier;
      }();

      var NullifiedChild = function () {
        var _NullifiedChild3 = function (_Nullifier2) {
          (0, _inherits3.default)(_NullifiedChild3, _Nullifier2);

          function _NullifiedChild3() {
            (0, _classCallCheck3.default)(this, _NullifiedChild3);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_NullifiedChild3).apply(this, arguments));
          }

          return _NullifiedChild3;
        }(Nullifier);

        Object.defineProperty(_NullifiedChild3, "name", {
          value: 'NullifiedChild',
          configurable: true
        });

        if ("onInherited" in Nullifier) {
          if (typeof Nullifier.onInherited == 'function') {
            var _NullifiedChild4 = Nullifier.onInherited(_NullifiedChild3);

            if (_NullifiedChild4 !== void 0) {
              if (typeof _NullifiedChild4 == 'function' && _NullifiedChild4.name !== 'NullifiedChild') {
                Object.defineProperty(_NullifiedChild4, "name", {
                  value: 'NullifiedChild',
                  configurable: true
                });
              }

              _NullifiedChild3 = _NullifiedChild4;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _NullifiedChild3;
      }();

      (0, _chai.expect)(NullifiedChild).to.equal(null);
    });

    it("has a reliable name property", function () {
      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {}
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child11 = function (_Parent6) {
          (0, _inherits3.default)(_Child11, _Parent6);

          function _Child11() {
            (0, _classCallCheck3.default)(this, _Child11);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child11).apply(this, arguments));
          }

          return _Child11;
        }(Parent);

        Object.defineProperty(_Child11, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child12 = Parent.onInherited(_Child11);

            if (_Child12 !== void 0) {
              if (typeof _Child12 == 'function' && _Child12.name !== 'Child') {
                Object.defineProperty(_Child12, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child11 = _Child12;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child11;
      }();

      (0, _chai.expect)(Child.name).to.equal("Child");
    });
  });

  describe("classes without an onInherited callback", function () {
    it("still function properly", function () {
      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'number',
          value: function number() {
            return 7;
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child13 = function (_Parent7) {
          (0, _inherits3.default)(_Child13, _Parent7);

          function _Child13() {
            (0, _classCallCheck3.default)(this, _Child13);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child13).apply(this, arguments));
          }

          (0, _createClass3.default)(_Child13, null, [{
            key: 'letter',
            value: function letter() {
              return "A";
            }
          }]);
          return _Child13;
        }(Parent);

        Object.defineProperty(_Child13, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child14 = Parent.onInherited(_Child13);

            if (_Child14 !== void 0) {
              if (typeof _Child14 == 'function' && _Child14.name !== 'Child') {
                Object.defineProperty(_Child14, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child13 = _Child14;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child13;
      }();

      (0, _chai.expect)(Child.number()).to.equal(7);
      (0, _chai.expect)(Child.letter()).to.equal("A");
      (0, _chai.expect)(Child.name).to.equal("Child");
    });
  });

  describe("when onInherited is called", function () {
    it("child class has a valid name property", function () {
      var Parent = function () {
        function Parent() {
          (0, _classCallCheck3.default)(this, Parent);
        }

        (0, _createClass3.default)(Parent, null, [{
          key: 'onInherited',
          value: function onInherited(child) {
            (0, _chai.expect)(child.name).to.equal("Child");
          }
        }]);
        return Parent;
      }();

      var Child = function () {
        var _Child15 = function (_Parent8) {
          (0, _inherits3.default)(_Child15, _Parent8);

          function _Child15() {
            (0, _classCallCheck3.default)(this, _Child15);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child15).apply(this, arguments));
          }

          return _Child15;
        }(Parent);

        Object.defineProperty(_Child15, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child16 = Parent.onInherited(_Child15);

            if (_Child16 !== void 0) {
              if (typeof _Child16 == 'function' && _Child16.name !== 'Child') {
                Object.defineProperty(_Child16, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child15 = _Child16;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child15;
      }();
    });
  });

  describe("When a grandchild inherits", function () {
    it("Grandparent.onInherited is still called", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function Grandparent() {
          (0, _classCallCheck3.default)(this, Grandparent);
        }

        (0, _createClass3.default)(Grandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Grandparent;
      }();

      var Parent = function () {
        var _Parent9 = function (_Grandparent) {
          (0, _inherits3.default)(_Parent9, _Grandparent);

          function _Parent9() {
            (0, _classCallCheck3.default)(this, _Parent9);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent9).apply(this, arguments));
          }

          return _Parent9;
        }(Grandparent);

        Object.defineProperty(_Parent9, "name", {
          value: 'Parent',
          configurable: true
        });

        if ("onInherited" in Grandparent) {
          if (typeof Grandparent.onInherited == 'function') {
            var _Parent10 = Grandparent.onInherited(_Parent9);

            if (_Parent10 !== void 0) {
              if (typeof _Parent10 == 'function' && _Parent10.name !== 'Parent') {
                Object.defineProperty(_Parent10, "name", {
                  value: 'Parent',
                  configurable: true
                });
              }

              _Parent9 = _Parent10;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Parent9;
      }();

      var Child = function () {
        var _Child17 = function (_Parent11) {
          (0, _inherits3.default)(_Child17, _Parent11);

          function _Child17() {
            (0, _classCallCheck3.default)(this, _Child17);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child17).apply(this, arguments));
          }

          return _Child17;
        }(Parent);

        Object.defineProperty(_Child17, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child18 = Parent.onInherited(_Child17);

            if (_Child18 !== void 0) {
              if (typeof _Child18 == 'function' && _Child18.name !== 'Child') {
                Object.defineProperty(_Child18, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child17 = _Child18;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child17;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Parent);
      (0, _chai.expect)(callback).to.have.been.calledWith(Child);
    });

    it("Grandparent.onInherited is not called if Parent redefined onInherited", function () {
      var callback = _sinon2.default.spy();

      var Grandparent = function () {
        function Grandparent() {
          (0, _classCallCheck3.default)(this, Grandparent);
        }

        (0, _createClass3.default)(Grandparent, null, [{
          key: 'onInherited',
          value: function onInherited(inheritor) {
            callback(inheritor);
          }
        }]);
        return Grandparent;
      }();

      var Parent = function () {
        var _Parent12 = function (_Grandparent2) {
          (0, _inherits3.default)(_Parent12, _Grandparent2);

          function _Parent12() {
            (0, _classCallCheck3.default)(this, _Parent12);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Parent12).apply(this, arguments));
          }

          (0, _createClass3.default)(_Parent12, null, [{
            key: 'onInherited',
            value: function onInherited() {
              // do nothing
            }
          }]);
          return _Parent12;
        }(Grandparent);

        Object.defineProperty(_Parent12, "name", {
          value: 'Parent',
          configurable: true
        });

        if ("onInherited" in Grandparent) {
          if (typeof Grandparent.onInherited == 'function') {
            var _Parent13 = Grandparent.onInherited(_Parent12);

            if (_Parent13 !== void 0) {
              if (typeof _Parent13 == 'function' && _Parent13.name !== 'Parent') {
                Object.defineProperty(_Parent13, "name", {
                  value: 'Parent',
                  configurable: true
                });
              }

              _Parent12 = _Parent13;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Parent12;
      }();

      var Child = function () {
        var _Child19 = function (_Parent14) {
          (0, _inherits3.default)(_Child19, _Parent14);

          function _Child19() {
            (0, _classCallCheck3.default)(this, _Child19);
            return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(_Child19).apply(this, arguments));
          }

          return _Child19;
        }(Parent);

        Object.defineProperty(_Child19, "name", {
          value: 'Child',
          configurable: true
        });

        if ("onInherited" in Parent) {
          if (typeof Parent.onInherited == 'function') {
            var _Child20 = Parent.onInherited(_Child19);

            if (_Child20 !== void 0) {
              if (typeof _Child20 == 'function' && _Child20.name !== 'Child') {
                Object.defineProperty(_Child20, "name", {
                  value: 'Child',
                  configurable: true
                });
              }

              _Child19 = _Child20;
            }
          } else {
            throw new TypeError("Attempted to call onInherited, but it was not a function");
          }
        }

        return _Child19;
      }();

      (0, _chai.expect)(callback).to.have.been.calledWith(Parent);
      (0, _chai.expect)(callback).not.to.have.been.calledWith(Child);
    });
  });
});